function [x,r,beta,W,H,Q,R,myPerfMeasure] = GMRESm(A_fun,x0,r0,beta,m,tolabs,myPerfMeasure)
    N               = size(r0,1);
    beta0           = beta;
    opts_UT         = [];
    opts_UT.UT      = true;
    W               = zeros(N,m+1);
    W(:,1)          = 1/beta * r0;
    gamma           = [beta; zeros(m,1)];
    G               = zeros(2,2,m);
    H               = zeros(m+1,m);
    Q               = eye(m+1,m+1);
    R               = zeros(m+1,m);
    for i=1:m
        W(:,i+1)        = A_fun( W(:,i) );
        for j=1:i
            H(j,i)          = W(:,j)' * W(:,i+1);
            W(:,i+1)        = W(:,i+1) - H(j,i) * W(:,j);
        end
        H(i+1,i)        = norm( W(:,i+1) );
        W(:,i+1)        = 1/H(i+1,i) * W(:,i+1);
        R(1:(i+1),i)    = H(1:(i+1),i);
        for j=1:(i-1)
            R([j,j+1],i)    = G(:,:,j) * R([j,j+1],i);
        end
        [Gl,Rl]         = qr(R([i,i+1],i));
        G(:,:,i)        = Gl;
        R([i,i+1],i)    = Rl;
        gamma([i,i+1],1)= Gl * gamma([i,i+1],1);
        Q([i,i+1],:)    = Gl * Q([i,i+1],:);
        beta            = abs( gamma(i+1,1) );
        if( beta <= tolabs )
            zeta            = linsolve( R(1:i,1:i), gamma(1:i,1), opts_UT );
            x               = x0 + W(:,1:i) * zeta;
            r               = W(:,1:(i+1)) * ( [beta0; zeros(i,1)] - H(1:(i+1),1:i) * zeta );
            break;
        end
    end
    if(beta > tolabs)
        x               = x0;
        r               = r0;
        beta            = beta0;
    end
    Q               = ( Q(1:m,1:(m+1)) )';
    R               = R(1:m,1:m);
end