function [W,Y,H,Q,R,x,r,beta, myPerfMeasure] = pGMRESm(A_fun,P,Z,V0,x,r,beta,m,tolabs, myPerfMeasure,xGlobal)
    [N,s]          	= size(P);
    W               = zeros(N,m+1);
    H               = zeros(m+1,m);
    Q               = eye(m+1,m+1);
    R               = zeros(m+1,m);
    G               = zeros(2,2,m);
    Y               = zeros(s,m+1);
    opts_L.LT       = true;
    opts_R.UT       = true;
    gamma           = [beta; zeros(m,1)];
    W(:,1)          = 1/beta * r;
    for i=1:m
        Y(:,i)          = P' * W(:,i);
        xi              = linsolve( Z, Y(:,i), opts_L);
        W(:,i+1)        = A_fun( W(:,i) - V0 * xi );
        for j=1:i
            H(j,i)          = W(:,j)' * W(:,i+1);
            W(:,i+1)        = W(:,i+1) - H(j,i) * W(:,j);
        end
        H(i+1,i)        = norm( W(:,i+1) );
        W(:,i+1)        = 1/H(i+1,i) * W(:,i+1);
        R(1:(i+1),i)    = H(1:(i+1),i);
        for j=1:(i-1)
            R([j,j+1],i)    = G(:,:,j) * R([j,j+1],i);
        end
        [Gl,Rl]        	= qr(R([i,i+1],i));
        G(:,:,i)        = Gl;
        R([i,i+1],i)    = Rl;
        Q([i,i+1],:)    = Gl * Q([i,i+1],:);
        gamma([i,i+1],1)= Gl * gamma([i,i+1],1);
        if( abs(gamma(i+1,1))<=tolabs )
            zeta            = linsolve(R(1:i,1:i), gamma(1:i,1), opts_R);
            x               = x + W(:,1:i) * zeta - V0 * linsolve( Z, Y(:,1:i) * zeta, opts_L );
            r(:,1)          = W(:,1:(i+1)) * ( [beta;zeros(i,1)] - H(1:(i+1),1:i) * zeta );
            beta            = abs(gamma(i+1,1));
            myPerfMeasure.stop();
            myPerfMeasure.read( xGlobal+x, beta );
            myPerfMeasure.resume();
            return;
        end
        % << PerfMeasure
        myPerfMeasure.stop();
        % % compute true residual
        zeta            = R(1:i,1:i) \ gamma(1:i,1);
        x_tmp          	= x + W(:,1:i) * zeta - V0 * linsolve( Z, Y(:,1:i) * zeta, opts_L );
        myPerfMeasure.read( xGlobal+x_tmp, abs(gamma(i+1,1)) );
        % >> PerfMeasure
        if( myPerfMeasure.isTerminate() )
            return;
        end
        myPerfMeasure.resume();
    end
    Y(:,m+1)        = P' * W(:,m+1);
    Q               = ( Q(1:m,1:(m+1)) )';
    R               = R(1:m,1:m);
end